diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index a12f7f9d2..a0b3b198c 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1,127 +1,45 @@
 package net.minecraft.client;
 
-import java.awt.Cursor;
-import java.awt.event.MouseAdapter;
-import java.awt.event.MouseEvent;
-import java.io.File;
-import java.io.IOException;
-import java.net.HttpURLConnection;
-import java.net.URL;
-import java.nio.file.Files;
-import java.util.*;
-
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 import it.unimi.dsi.fastutil.objects.Object2LongLinkedOpenHashMap;
 import it.unimi.dsi.fastutil.objects.Object2LongMap;
 import net.minecraft.client.console.LogMessageReceiver;
 import net.minecraft.client.console.shell.BindManager;
+import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.entity.ClientSkinVariantList;
 import net.minecraft.client.entity.player.PlayerLocal;
+import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.client.enums.EnumGPUVendor;
-import net.minecraft.client.gui.*;
+import net.minecraft.client.gui.ExceptionPopupElement;
+import net.minecraft.client.gui.MainMenuBackground;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.ScreenConnecting;
+import net.minecraft.client.gui.ScreenConsole;
+import net.minecraft.client.gui.ScreenGameOver;
+import net.minecraft.client.gui.ScreenMainMenu;
+import net.minecraft.client.gui.ScreenPause;
+import net.minecraft.client.gui.ScreenPhotoMode;
+import net.minecraft.client.gui.ScreenSleepSP;
+import net.minecraft.client.gui.ScreenStats;
+import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.achievements.ScreenAchievements;
 import net.minecraft.client.gui.chat.ScreenChat;
 import net.minecraft.client.gui.chat.ScreenSleepMP;
+import net.minecraft.client.gui.container.ScreenInventory;
+import net.minecraft.client.gui.container.ScreenInventoryCreative;
 import net.minecraft.client.gui.error.ScreenBadJavaArch;
 import net.minecraft.client.gui.error.ScreenConflictWarning;
 import net.minecraft.client.gui.error.ScreenMissingMinecraft;
 import net.minecraft.client.gui.error.ScreenOutOfMemory;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.options.data.OptionsPages;
+import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.server.ScreenSelectServer;
+import net.minecraft.client.gui.subtitles.SubtitleTracker;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
-import net.minecraft.client.player.controller.PlayerControllerSP;
-import net.minecraft.client.render.EntityRendererDispatcher;
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.renderer.CompareFunc;
-import net.minecraft.client.render.renderer.CullFace;
-import net.minecraft.client.render.renderer.GLRenderer;
-import net.minecraft.client.render.renderer.Shaders;
-import net.minecraft.client.render.renderer.State;
-import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
-import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
-import net.minecraft.client.world.save.SaveHandlerClientSP;
-import net.minecraft.client.net.handler.PacketHandlerClient;
-import net.minecraft.client.render.TileEntityRenderDispatcher;
-import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.font.FontRendererDefault;
-import net.minecraft.client.render.terrain.TerrainRendererMultiDraw;
-import net.minecraft.client.util.helper.UrlHelper;
-import net.minecraft.client.world.WorldClient;
-import net.minecraft.client.world.WorldClientMP;
-import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
-import net.minecraft.core.achievement.Achievements;
-import net.minecraft.core.block.BlockLogicLeavesBase;
-import net.minecraft.core.block.entity.TileEntityDispatcher;
-import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.net.command.CommandManager;
-import net.minecraft.core.net.command.commands.CommandAchievement;
-import net.minecraft.core.net.command.commands.CommandBiome;
-import net.minecraft.core.net.command.commands.CommandChunk;
-import net.minecraft.core.net.command.commands.CommandClear;
-import net.minecraft.core.net.command.commands.CommandClone;
-import net.minecraft.core.net.command.commands.CommandDamage;
-import net.minecraft.core.net.command.commands.CommandFill;
-import net.minecraft.core.net.command.commands.CommandGameMode;
-import net.minecraft.core.net.command.commands.CommandGameRule;
-import net.minecraft.core.net.command.commands.CommandGive;
-import net.minecraft.core.net.command.commands.CommandHeal;
-import net.minecraft.core.net.command.commands.CommandHelp;
-import net.minecraft.core.net.command.commands.CommandKill;
-import net.minecraft.core.net.command.commands.CommandMessage;
-import net.minecraft.core.net.command.commands.CommandMobSpawning;
-import net.minecraft.core.net.command.commands.CommandPlace;
-import net.minecraft.core.net.command.commands.CommandPlaySound;
-import net.minecraft.core.net.command.commands.CommandSay;
-import net.minecraft.core.net.command.commands.CommandSeed;
-import net.minecraft.core.net.command.commands.CommandSetBlock;
-import net.minecraft.core.net.command.commands.CommandSetSpawn;
-import net.minecraft.core.net.command.commands.CommandSpawn;
-import net.minecraft.core.net.command.commands.CommandParticle;
-import net.minecraft.core.net.command.commands.CommandSummon;
-import net.minecraft.core.net.command.commands.CommandTeleport;
-import net.minecraft.core.net.command.commands.CommandTellRaw;
-import net.minecraft.core.net.command.commands.CommandTestFor;
-import net.minecraft.core.net.command.commands.CommandTime;
-import net.minecraft.core.net.command.commands.CommandWeather;
-import net.minecraft.core.net.command.util.CommandHelper;
-import net.minecraft.core.player.gamemode.Gamemodes;
-import net.minecraft.core.util.pool.ObjectPool;
-import net.minecraft.core.util.helper.Color;
-import net.minecraft.core.util.helper.DyeColor;
-import net.minecraft.core.util.helper.LoggedPrintStream;
-import net.minecraft.core.util.helper.UUIDHelper;
-import net.minecraft.core.world.pos.TilePos;
-import net.minecraft.core.world.pos.TilePosc;
-import net.minecraft.core.world.save.SaveFormatBase;
-import net.minecraft.core.world.settings.WorldConfiguration;
-import net.minecraft.core.world.type.WorldType;
-
-import javax.imageio.ImageIO;
-import javax.swing.JLabel;
-import javax.swing.JOptionPane;
-
-import net.minecraft.client.gui.subtitles.SubtitleTracker;
-import net.minecraft.client.sound.SoundRepository;
-import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
-
-import org.joml.Matrix4f;
-import org.joml.primitives.AABBd;
-import org.joml.primitives.AABBdc;
-import org.lwjgl.LWJGLException;
-import org.lwjgl.glfw.GLFW;
-import org.lwjgl.input.Keyboard;
-import org.lwjgl.input.Mouse;
-
-import net.minecraft.client.discord.RichPresenceHandlerThread;
-import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
-import net.minecraft.client.gui.hud.HudIngame;
-import net.minecraft.client.gui.container.ScreenInventory;
-import net.minecraft.client.gui.container.ScreenInventoryCreative;
-import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
-import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.input.InputHandler;
 import net.minecraft.client.input.InputType;
@@ -129,48 +47,73 @@ import net.minecraft.client.input.MouseInput;
 import net.minecraft.client.input.PlayerInput;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.input.controller.Joystick;
+import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.net.thread.ThreadDownloadResources;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerController;
-import net.minecraft.client.render.ParticleEngine;
+import net.minecraft.client.player.controller.PlayerControllerSP;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.LoadingScreenRenderer;
 import net.minecraft.client.render.OpenGLHelper;
+import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.PostProcessingManager;
-import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.RenderGlobal;
 import net.minecraft.client.render.Renderer;
+import net.minecraft.client.render.TextureManager;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.WorldRenderer;
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.camera.EntityCameraFirstPerson;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.FontRendererDefault;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.renderer.CompareFunc;
+import net.minecraft.client.render.renderer.CullFace;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.shader.ShadersRenderer;
 import net.minecraft.client.render.terrain.ChunkRenderer;
 import net.minecraft.client.render.terrain.TerrainRenderer;
+import net.minecraft.client.render.terrain.TerrainRendererMultiDraw;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.client.render.window.GameWindow;
 import net.minecraft.client.render.window.GameWindowGLFW;
 import net.minecraft.client.sound.SoundEngine;
-import net.minecraft.core.util.debug.Debug;
+import net.minecraft.client.sound.SoundRepository;
 import net.minecraft.client.util.debug.DebugRender;
+import net.minecraft.client.util.helper.ScreenShot;
 import net.minecraft.client.util.helper.ScreenshotHelper;
 import net.minecraft.client.util.helper.Textures;
+import net.minecraft.client.util.helper.UrlHelper;
+import net.minecraft.client.world.WorldClient;
+import net.minecraft.client.world.WorldClientMP;
+import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
+import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
+import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
+import net.minecraft.client.world.save.SaveHandlerClientSP;
 import net.minecraft.core.Global;
 import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.MinecraftError;
 import net.minecraft.core.MinecraftException;
 import net.minecraft.core.Timer;
 import net.minecraft.core.UnexpectedThrowable;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.achievement.stat.StatsCounter;
+import net.minecraft.core.block.BlockLogicLeavesBase;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.entity.player.Player;
@@ -179,16 +122,53 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.PlayerProfile;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.net.command.commands.CommandAchievement;
+import net.minecraft.core.net.command.commands.CommandBiome;
+import net.minecraft.core.net.command.commands.CommandChunk;
+import net.minecraft.core.net.command.commands.CommandClear;
+import net.minecraft.core.net.command.commands.CommandClone;
+import net.minecraft.core.net.command.commands.CommandDamage;
+import net.minecraft.core.net.command.commands.CommandFill;
+import net.minecraft.core.net.command.commands.CommandGameMode;
+import net.minecraft.core.net.command.commands.CommandGameRule;
+import net.minecraft.core.net.command.commands.CommandGive;
+import net.minecraft.core.net.command.commands.CommandHeal;
+import net.minecraft.core.net.command.commands.CommandHelp;
+import net.minecraft.core.net.command.commands.CommandKill;
+import net.minecraft.core.net.command.commands.CommandMessage;
+import net.minecraft.core.net.command.commands.CommandMobSpawning;
+import net.minecraft.core.net.command.commands.CommandParticle;
+import net.minecraft.core.net.command.commands.CommandPlace;
+import net.minecraft.core.net.command.commands.CommandPlaySound;
+import net.minecraft.core.net.command.commands.CommandSay;
+import net.minecraft.core.net.command.commands.CommandSeed;
+import net.minecraft.core.net.command.commands.CommandSetBlock;
+import net.minecraft.core.net.command.commands.CommandSetSpawn;
+import net.minecraft.core.net.command.commands.CommandSpawn;
+import net.minecraft.core.net.command.commands.CommandSummon;
+import net.minecraft.core.net.command.commands.CommandTeleport;
+import net.minecraft.core.net.command.commands.CommandTellRaw;
+import net.minecraft.core.net.command.commands.CommandTestFor;
+import net.minecraft.core.net.command.commands.CommandTime;
+import net.minecraft.core.net.command.commands.CommandWeather;
+import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.player.Session;
 import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
+import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.LoggedPrintStream;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.client.util.helper.ScreenShot;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Time;
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.PortalHandler;
 import net.minecraft.core.world.World;
@@ -197,19 +177,49 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.ISaveConverter;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveConverters;
+import net.minecraft.core.world.save.SaveFormatBase;
 import net.minecraft.core.world.save.SaveFormats;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Matrix4f;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
+import org.lwjgl.LWJGLException;
+import org.lwjgl.glfw.GLFW;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL41;
 import org.lwjgl.system.Configuration;
 import org.slf4j.Logger;
 import org.useless.dragonfly.data.entity.mojang.EntityGeometryMojangData;
 
+import javax.imageio.ImageIO;
+import javax.swing.*;
+import java.awt.*;
+import java.awt.event.MouseAdapter;
+import java.awt.event.MouseEvent;
+import java.io.File;
+import java.io.IOException;
+import java.net.HttpURLConnection;
+import java.net.URL;
+import java.nio.file.Files;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Comparator;
+import java.util.List;
+import java.util.Objects;
+import java.util.Random;
+import java.util.UUID;
 
 import static net.minecraft.core.Global.CURRENT_SAVE_VERSION;
 
@@ -250,7 +260,6 @@ public class Minecraft
     public HudIngame hudIngame;
     public boolean skipRenderWorld;
     public @Nullable HitResult objectMouseOver;
-    public final @NotNull GameSettings gameSettings;
     public @NotNull SoundEngine sndManager;
     public final @NotNull SubtitleTracker subtitleTracker = new SubtitleTracker();
     public final @NotNull TexturePackList texturePackList;
@@ -325,9 +334,8 @@ public class Minecraft
         INSTANCE = this;
 
         this.mcDataDir = mcDataDir;
-        this.gameSettings = new GameSettings(this, mcDataDir);
         this.texturePackList = new TexturePackList(this, this.mcDataDir);
-        this.textureManager = new TextureManager(this, this.texturePackList, this.gameSettings);
+        this.textureManager = new TextureManager(this, this.texturePackList);
         this.font = new FontRendererDefault();
 
         if (test) return;
@@ -387,21 +395,20 @@ public class Minecraft
         if (!this.gameStarted) {
             this.running = false;
 
-            LOGGER.error("An exception has occurred while trying to start the game!", throwable.exception);
+            LOGGER.error("An exception has occurred while trying to start the game!\n{}", throwable.description, throwable.exception);
 
-            this.gameWindow.displayCrashReport(throwable, 1);
+//            this.gameWindow.displayCrashReport(throwable, 1);
             this.hasCrashed = true;
             shutdownMinecraftApplet();
             return;
         }
 
-        boolean disableCrashHandler = this.gameSettings.disableCrashHandler.value;
-        if (disableCrashHandler) {
+        if (GameSettings.DISABLE_CRASH_HANDLER.value) {
             this.running = false;
 
-            LOGGER.error("An exception has occurred while trying to start the game!", throwable.exception);
+            LOGGER.error("An exception has occurred while trying to start the game!\n{}", throwable.description, throwable.exception);
 
-            this.gameWindow.displayCrashReport(throwable, 1);
+//            this.gameWindow.displayCrashReport(throwable, 1);
             this.hasCrashed = true;
             shutdownMinecraftApplet();
             return;
@@ -410,9 +417,9 @@ public class Minecraft
         if (this.hasCrashed) {
             this.running = false;
 
-            LOGGER.error("An exception has occurred while trying to start the game!", throwable.exception);
+            LOGGER.error("An exception has occurred while trying to start the game!\n{}", throwable.description, throwable.exception);
 
-            this.gameWindow.displayCrashReport(throwable, 2);
+//            this.gameWindow.displayCrashReport(throwable, 2);
             shutdownMinecraftApplet();
             return;
         }
@@ -481,7 +488,6 @@ public class Minecraft
     public void startGame() throws LWJGLException {
         // Initialize LogMessageReceiver to capture output
         LogMessageReceiver.init();
-
         Holidays.initialize();
 
         // Manually initialize blocks and items
@@ -493,15 +499,13 @@ public class Minecraft
         CommandHelper.init();
         initCommands();
 
-        this.gameSettings.init();
+        GameSettings.init(this.mcDataDir);
 
-        UUIDHelper.urlUUID = this.gameSettings.uuidServer.value;
+        UUIDHelper.urlUUID = GameSettings.UUID_SERVER.value;
 
         LOGGER.info("Java Version: {}", System.getProperty("java.version"));
 
-        printWrongJavaVersionInfo();
-
-        this.gameWindow.init(this, this.overrideWidth != null ? this.overrideWidth : this.gameSettings.windowWidth.value, this.overrideHeight != null ? this.overrideHeight : this.gameSettings.windowHeight.value);
+        this.gameWindow.init(this, this.overrideWidth != null ? this.overrideWidth : GameSettings.WINDOW_WIDTH.value, this.overrideHeight != null ? this.overrideHeight : GameSettings.WINDOW_HEIGHT.value);
         this.font.init();
 
         final @Nullable String vendorString = GL41.glGetString(GL41.GL_VENDOR);
@@ -511,18 +515,18 @@ public class Minecraft
 
         LOGGER.info("Resolution: {} x {}", this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels());
 
-        this.resolution.setScale(this.gameSettings.guiScale.value);
+        this.resolution.setScale(GameSettings.GUI_SCALE.value);
 
         SaveFormatBase handlerBase = new SaveFormat19134(new File(this.mcDataDir, "saves"));
         handlerBase.factory = SaveHandlerClientSP::new;
         this.saveFormat = handlerBase;
-        I18n.initialize(this.gameSettings.language.value);
+        I18n.initialize(GameSettings.LANGUAGE.value);
 
-        if (!this.gameSettings.startInFullscreen.value) {
-            this.gameSettings.fullscreen.value = false;
+        if (!GameSettings.START_IN_FULLSCREEN.value) {
+            GameSettings.FULLSCREEN.value = false;
         }
 
-        this.resolution.setScale(this.gameSettings.guiScale.value);
+        this.resolution.setScale(GameSettings.GUI_SCALE.value);
 
         this.terrainRenderer = new TerrainRendererMultiDraw(this);
 
@@ -536,7 +540,6 @@ public class Minecraft
         SoundRepository.initialize(this);
 
         GLRenderer.init();
-
         // Show load screen as early as possible
         // Do not put stuff that takes a while to load before this,
         // otherwise the loading time will happen while the window is black
@@ -554,16 +557,15 @@ public class Minecraft
         ItemModelDispatcher.getInstance();
 
         loadScreen();    // Update loading screen so it doesn't say no response
-
         LOGGER.info("Initializing input");
         try {
             InputHandler.init(this);
 
-            this.controllerInput = InputHandler.getController(this.gameSettings.selectedController.value);
+            this.controllerInput = InputHandler.getController(GameSettings.SELECTED_CONTROLLER.value);
         } catch (Exception e) {
             LOGGER.error("Input init error!", e);
         }
-        this.mouseInput.setRawInput(this.gameSettings.rawMouseInput.value);
+        this.mouseInput.setRawInput(GameSettings.RAW_MOUSE_INPUT.value);
         LOGGER.info("Input done!");
 
         LOGGER.info("Setting up OpenGL values...");
@@ -576,7 +578,7 @@ public class Minecraft
         GLRenderer.projectionM4f().identity();
         GLRenderer.viewM4f().identity();
         OpenGLHelper.checkError("startup");
-        this.sndManager.init(this.gameSettings);
+        this.sndManager.init();
 
         loadScreen();    // Update loading screen so it doesn't say no response
 
@@ -627,22 +629,22 @@ public class Minecraft
         StatList.init();
         this.statsCounter = new StatsCounter(this.session, this.mcDataDir);
         Achievements.OPEN_INVENTORY.setDescriptionFormatter(s -> {
-            if (!this.gameSettings.keyInventory.isBound()) {
+            if (!GameSettings.KEY_INVENTORY.isBound()) {
                 return "Set your inventory keybind in the controls menu!";
             }
-            return String.format(s, this.gameSettings.keyInventory.getKeyName());
+            return String.format(s, GameSettings.KEY_INVENTORY.getKeyName());
         });
         Achievements.OPEN_GUIDEBOOK.setDescriptionFormatter(s -> {
-            if (!this.gameSettings.keyGuidebook.isBound()) {
+            if (!GameSettings.KEY_GUIDEBOOK.isBound()) {
                 return "Set your guidebook keybind in the controls menu!";
             }
-            return String.format(s, this.gameSettings.keyGuidebook.getKeyName());
+            return String.format(s, GameSettings.KEY_GUIDEBOOK.getKeyName());
         });
 
         loadScreen();    // Update loading screen so it doesn't say no response
 
         // Enable Discord Rich Presence
-        if (this.gameSettings.discordRichPresence.value) {
+        if (GameSettings.DISCORD_RICH_PRESENCE.value) {
             // This thing takes forever to load, so it has been moved down here,
             // so that the loading time is spent on the loading screen and not a black screen
             this.rpcThread = new RichPresenceHandlerThread(this);
@@ -709,26 +711,6 @@ public class Minecraft
         CommandManager.registerCommand(new CommandParticle());
     }
 
-    private void printWrongJavaVersionInfo() {
-        String javaVersion = System.getProperty("java.version");
-        if (getOs() != EnumOS.linux || javaVersion == null) {
-            return;
-        }
-        try {
-            int major = Integer.parseInt(javaVersion.split("\\.")[0]);
-            if (major > 8) {
-                LOGGER.warn("Detected a probably incompatible Java version. If the game crashes with a message similar to \n"
-                    + "\"Inconsistency detected by ld.so: dl-lookup.c: 111: check_match: Assertion `version->filename == NULL || ! _dl_name_match_p (version->filename, map)' failed!\", \n"
-                    + "use Java 8!");
-            }
-        } catch (Exception e) {
-            LOGGER.error("Failed to retrieve Java version!", e);
-            LOGGER.warn("If the game crashes with a message similar to \n"
-                + "\"Inconsistency detected by ld.so: dl-lookup.c: 111: check_match: Assertion `version->filename == NULL || ! _dl_name_match_p (version->filename, map)' failed!\", \n"
-                + "use Java 8!");
-        }
-    }
-
     public @NotNull Matrix4f getGuiProjectionMatrix(@NotNull Matrix4f dest) {
         return dest.identity().ortho(0.0f, (float) this.resolution.getExactScaledWidthScreenCoords(), (float) this.resolution.getExactScaledHeightScreenCoords(), 0.0f, 1000f, 3000f);
     }
@@ -794,7 +776,7 @@ public class Minecraft
 
     @Override
     public IChunkProvider createChunkProvider(World world, IChunkLoader chunkLoader) {
-        return switch (this.gameSettings.enableThreadedChunkProvider.value) {
+        return switch (GameSettings.CHUNK_PROVIDER.value) {
             case DYNAMIC ->
                 new ChunkProviderDynamic(world, chunkLoader, world.getWorldType().createChunkGenerator(world));
 
@@ -891,32 +873,43 @@ public class Minecraft
     }
 
     public void shutdownMinecraftApplet() {
-        // This could be called very early if the game crashes, so everything could be null!
+        LOGGER.info("Shutting Down");
         try {
-            if (this.gameSettings != null) {
-                this.gameSettings.saveOptions();
-            }
-        } catch (Exception e) {
+            GameSettings.saveOptions();
+        } catch (Throwable e) {
             LOGGER.error("Exception occurred while saving settings! Some settings may be lost!", e);
         }
         if (this.statsCounter != null) {
-            this.statsCounter.fetchStats();
-            this.statsCounter.saveStats();
+            try {
+                this.statsCounter.fetchStats();
+                this.statsCounter.saveStats();
+            } catch (Throwable throwable) {
+                LOGGER.error("Failed to save stats!");
+            }
         }
-        LOGGER.info("Stopping!");
-        try {
-            changeWorld(null);
-        } catch (Throwable ignored) {
+        if (this.currentWorld != null) {
+            try {
+                changeWorld(null);
+            } catch (Throwable throwable) {
+                LOGGER.error("Failed to close world!", throwable);
+            }
         }
         try {
-            GLAllocation.deleteTexturesAndDisplayLists();
-        } catch (Throwable ignored) {
+            if (OpenGLHelper.contextCreated) {
+                GLAllocation.deleteTextures();
+            }
+        } catch (Throwable throwable) {
+            LOGGER.error("Failed to free texture handles!", throwable);
         }
-        if (this.sndManager != null) {
+        try {
             this.sndManager.destroy();
+        } catch (Throwable throwable) {
+            LOGGER.error("Failed to close sound manager!", throwable);
         }
-        if (this.gameWindow != null) {
+        try {
             this.gameWindow.free();
+        } catch (Throwable throwable) {
+            LOGGER.error("Failed to free window resources!", throwable);
         }
         System.gc();
         if (!this.hasCrashed) {
@@ -986,8 +979,8 @@ public class Minecraft
                     Debug.push("misc");        // 2
 
                     OpenGLHelper.checkError("pre render");
-                    EntityItem.enableItemClumping = this.gameSettings.enableItemClumping.value;
-                    BlockLogicLeavesBase.enableTreeShadowing = this.gameSettings.treeShadows.value;
+                    EntityItem.enableItemClumping = GameSettings.ENABLE_ITEM_CLUMPING.value;
+                    BlockLogicLeavesBase.enableTreeShadowing = GameSettings.TREE_SHADOWS.value;
                     this.sndManager.updateListener(this.thePlayer, this.timer.partialTicks);
 //                    glEnable(GL_TEXTURE_2D);
                     if (this.currentWorld != null) {
@@ -1004,7 +997,7 @@ public class Minecraft
                     Debug.change("misc"); // 2
 
                     if (this.thePlayer != null && this.thePlayer.isInWall()) {
-                        this.gameSettings.thirdPersonView.value = 0;
+                        GameSettings.THIRD_PERSON_VIEW.value = 0;
                     }
 
                     Debug.change("displayupdate"); // 2
@@ -1024,7 +1017,7 @@ public class Minecraft
                         this.worldRenderer.updateCameraAndRender(this.timer.partialTicks);
                     }
 
-                    if (this.gameSettings.pauseOnLostFocus.value) {
+                    if (GameSettings.PAUSE_ON_LOST_FOCUS.value) {
                         if (!this.gameWindow.isFocused()) {
                             if (System.currentTimeMillis() > this.lastFocusTime + 250) {
                                 displayInGameMenu();
@@ -1033,7 +1026,7 @@ public class Minecraft
                             this.lastFocusTime = System.currentTimeMillis();
                         }
                     }
-                    this.sndManager.setMuted(this.gameSettings.muteOnLostFocus.value && !this.gameWindow.isFocused());
+                    this.sndManager.setMuted(GameSettings.MUTE_ON_LOST_FOCUS.value && !this.gameWindow.isFocused());
 
                     switch (this.downloadResourcesThread.downloading) {
                         case DOWNLOADING: {
@@ -1122,7 +1115,7 @@ public class Minecraft
 
                     Debug.pop();    // 2
                     Debug.pop();    // 1
-                    if (this.gameSettings.showFrameTimes.value) {
+                    if (GameSettings.SHOW_FRAME_TIMES.value) {
                         DebugRender.render(this.font);
                     }
 
